<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'certificate';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';
 
// 证书上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/certificate/'); // 实例化类文件(文件上传路径，结尾加斜杠)
                                                        
// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('ur_here', $_LANG['certificate']);
$smarty->assign('certificate_list', get_certificate_list());

/**
 * +----------------------------------------------------------
 * 证书列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    $smarty->assign('btn_lang', $dou->btn_lang('certificate', '', 'name'));
    
    $smarty->display('certificate.htm');
} 

/**
 * +----------------------------------------------------------
 * 证书添加处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'insert') {
    // 验证证书名称
    if (empty($_POST['name'])) $dou->dou_msg($_LANG['certificate_name'] . $_LANG['is_empty']);
    
    // 验证是否上传证书
    if (empty($_FILES['image']['name'])) $dou->dou_msg($_LANG['certificate_image'] . $_LANG['is_empty']);

    // 文件上传盒子
    $image = $file->box('certificate', $dou->auto_id('certificate'), 'image', 'main');

    // 格式化数据
    $add_time = time();

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);

    $sql = "INSERT INTO " . $dou->table('certificate') . " (id, name, image, add_time, sort)" . " VALUES (NULL, '$_POST[name]', '$image', '$add_time', '$_POST[sort]')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['certificate_add'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['certificate_add_succes'], 'certificate.php');
} 

/**
 * +----------------------------------------------------------
 * 证书编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $certificate = $dou->get_row('certificate', '*', "id = '$id'");
    
    // 格式化数据
    $certificate['image'] = $dou->dou_file($certificate['image']);
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('certificate', $certificate);
    $smarty->assign('btn_lang', $dou->btn_lang('certificate', $id, 'name'));
    
    $smarty->display('certificate.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // 验证证书名称
    if (empty($_POST['name'])) $dou->dou_msg($_LANG['certificate_name'] . $_LANG['is_empty']);
    
    // 文件上传盒子
    $image = $file->box('certificate', $id, 'image', 'main');
    $image = $image ? ", image = '" . $image . "'" : '';

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "update " . $dou->table('certificate') . " SET name='$_POST[name]'" . $image . " , sort = '$_POST[sort]' WHERE id = '$id'";
    $dou->query($sql);
    $dou->create_admin_log($_LANG['certificate_edit'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['certificate_edit_succes'], 'certificate.php');
} 

/**
 * +----------------------------------------------------------
 * 证书删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'certificate.php');
    $name = $dou->get_one("SELECT name FROM " . $dou->table('certificate') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm'])) {
        // 删除相应商品证书
        $image = $dou->get_one("SELECT image FROM " . $dou->table('certificate') . " WHERE id = '$id'");
        $dou->del_file($image);
     
        // 删除对应语言项
        if ($_OPEN['language'])
            $dou->del_lang_value('certificate', $id);
        
        $dou->create_admin_log($_LANG['certificate_del'] . ': ' . $name);
        $dou->delete('certificate', "id = $id", 'certificate.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'certificate.php', '', '30', "certificate.php?rec=del&id=$id");
    }
}
    
/**
 * +----------------------------------------------------------
 * 获取证书列表
 * +----------------------------------------------------------
 */
function get_certificate_list() {
    $sql = "SELECT * FROM " . $GLOBALS['dou']->table('certificate'). " ORDER BY sort ASC, id ASC";
    $query = $GLOBALS['dou']->query($sql);
    while ($row = $GLOBALS['dou']->fetch_array($query)) {
        $certificate_list[] = array (
                "id" => $row['id'],
                "name" => $row['name'],
                "image" => $GLOBALS['dou']->dou_file($row['image']),
                "add_time" => $row['add_time'],
                "sort" => $row['sort'] 
        );
    }
    
    return $certificate_list;
}
?>